package foele.jini.event;

/**
 * Insert the type's description here.
 * Creation date: (15/08/99 12.33.08)
 * @author: 
 */
public class RemoteBeanEvent extends net.jini.core.event.RemoteEvent {
	private java.lang.Object[] args;
	private java.lang.Class[] argsType;
	private java.lang.Class Class;
	private java.lang.String Method;
	public static final int REMOTE_BEAN_EVENT = 17773;
/**
 * RemoteBeanEvent constructor comment.
 * @param arg1 java.lang.Object
 * @param arg2 long
 * @param arg3 long
 * @param arg4 java.rmi.MarshalledObject
 */
public RemoteBeanEvent(Object source, long seqNum, java.rmi.MarshalledObject handback,java.lang.reflect.Method Method,Object[] args) {
	super(source, REMOTE_BEAN_EVENT, seqNum, handback);
	this.args=args;
	Class=Method.getDeclaringClass();
	argsType=Method.getParameterTypes();
	this.Method=Method.getName();
}
/**
 * Insert the method's description here.
 * Creation date: (14/08/99 9.19.56)
 * @return java.lang.Object[]
 */
public Object[] getArgs() {
	return args;
}
/**
 * Insert the method's description here.
 * Creation date: (14/08/99 9.20.20)
 * @return java.lang.reflect.Method
 */
public java.lang.reflect.Method getMethod() {
	try {
		return Class.getDeclaredMethod(Method,argsType);
	}
	catch (NoSuchMethodException e){
		throw new NoSuchMethodError(e.getMessage());
	}
		
}
}
