package foele.jini.event;

/**
 * Insert the type's description here.
 * Creation date: (13/08/99 15.57.53)
 * @author: 
 */
public class RemoteBeanEventListener extends java.rmi.server.UnicastRemoteObject implements net.jini.core.event.RemoteEventListener {
	private java.util.Vector Listeners = new java.util.Vector();
	private java.lang.Class ListenersType;
	private RemoteBeanEventFirer RemoteBeanEventFirer;
	private com.sun.jini.lease.LeaseRenewalManager LeaseRenewalManager;
	protected class LeaseRenewalManagerEventListener implements com.sun.jini.lease.LeaseListener {
		public LeaseRenewalManagerEventListener() throws java.rmi.RemoteException {
			super();
		}
		public void notify(com.sun.jini.lease.LeaseRenewalEvent LRE) {
			try {
				LeaseRenewalManager.remove(LRE.getLease());
			}
			catch (net.jini.core.lease.UnknownLeaseException e){}
			net.jini.core.event.EventRegistration ER=null;
			while (ER==null) {
				try {
					ER=RemoteBeanEventFirer.addRemoteBeanEventListener(RemoteBeanEventListener.this);
				}
				catch (Exception e){
					e.printStackTrace(System.out);
				}
			}
			LeaseRenewalManager.renewFor(ER.getLease(),net.jini.core.lease.Lease.FOREVER,this);
		}
	}
	private long seqNum;
/**
 * RemoteBeanEventListener constructor comment.
 * @exception java.rmi.RemoteException The exception description.
 */
protected RemoteBeanEventListener() throws java.rmi.RemoteException {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 16.13.01)
 * @param RemoteBeanEventFirer foele.jini.exent.RemoteBeanEventFirer
 * @param ListenersType java.lang.Class
 */
public RemoteBeanEventListener(RemoteBeanEventFirer RemoteBeanEventFirer, Class ListenersType) throws java.rmi.RemoteException {
	this();
	this.RemoteBeanEventFirer=RemoteBeanEventFirer;
	this.ListenersType=ListenersType;
	net.jini.core.event.EventRegistration ER=null;
	try {
		ER=RemoteBeanEventFirer.addRemoteBeanEventListener(this);
	}
	catch (net.jini.core.lease.LeaseDeniedException e){
		throw new java.rmi.RemoteException("Lease Denied from RemoteBean EventFirer "+ RemoteBeanEventFirer,e);
	}
	LeaseRenewalManager=new com.sun.jini.lease.LeaseRenewalManager(ER.getLease(),net.jini.core.lease.Lease.FOREVER,new RemoteBeanEventListener.LeaseRenewalManagerEventListener());
	seqNum=ER.getSequenceNumber();
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 16.17.13)
 * @param Listener java.util.EventListener
 * @exception java.lang.ClassCastException The exception description.
 */
public synchronized void addListener(java.util.EventListener Listener) throws java.lang.ClassCastException {
	if (getListenersType().isInstance(Listener))
		Listeners.addElement(Listener);
	else throw new ClassCastException();
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 16.18.31)
 */
public Class getListenersType() {
	return ListenersType;
}
/**
 * notify method comment.
 */
public void notify(net.jini.core.event.RemoteEvent RE) throws java.rmi.RemoteException, net.jini.core.event.UnknownEventException {
	if (RE instanceof RemoteBeanEvent && RE.getID()==RemoteBeanEvent.REMOTE_BEAN_EVENT){
		final RemoteBeanEvent RBE=(RemoteBeanEvent)RE;
		if (seqNum<RBE.getSequenceNumber()){
			seqNum=RBE.getSequenceNumber();
			new Thread(new Runnable () {
				public void run() {
					synchronized (RemoteBeanEventListener.this) {
						for (int i=0;i<Listeners.size();i++) {
							try{
								RBE.getMethod().invoke(Listeners.elementAt(i),RBE.getArgs());
							}
							catch (Exception e){
								e.printStackTrace(System.out);
							}				
						}
					}
				}
			}).start();
		}
	}
	else throw new net.jini.core.event.UnknownEventException();
	
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 16.18.00)
 * @param Listener java.util.EventListener
 * @exception java.lang.ClassCastException The exception description.
 */
public synchronized void removeListener(java.util.EventListener Listener) throws java.lang.ClassCastException {
	if (getListenersType().isInstance(Listener))
		Listeners.removeElement(Listener);
	else throw new ClassCastException();
}
}
