package foele.jini.lease;

/**
 * This type was created in VisualAge.
 */
public class DefaultLeasePolicy implements LeasePolicy {
	private LeaseManager LeaseManager;
	private LeaseFactory LeaseFactory;
/**
 * DefaultLeasePolicy constructor comment.
 */
public DefaultLeasePolicy(LeaseManager LeaseManager) {
	super();
	this.LeaseManager=LeaseManager;
}
/**
 * DefaultLeasePolicy constructor comment.
 */
public DefaultLeasePolicy(LeaseManager LeaseManager,LeaseFactory LeaseFactory) {
	super();
	this.LeaseManager=LeaseManager;
	this.LeaseFactory=LeaseFactory;
}
/**
 * createNewLease method comment.
 */
public net.jini.core.lease.Lease createNewLease(long leaseFor, LeasedResource leasedresource) throws net.jini.core.lease.LeaseDeniedException {
	//System.out.println("Policy create:"+ leaseFor);
	if (leaseFor==net.jini.core.lease.Lease.ANY || leaseFor==net.jini.core.lease.Lease.FOREVER)
		leaseFor=Long.MAX_VALUE;
	return LeaseFactory.createNewLease(leaseFor,LeaseManager);
}
/**
 * renew method comment.
 */
public long renew(long leaseFor, net.jini.core.lease.Lease lease) throws net.jini.core.lease.LeaseDeniedException, net.jini.core.lease.UnknownLeaseException {
	return leaseFor;
}
}
